;
; Oyd11, 1st try on GBA:
; assembled with goldroad ARM 1.7
;

	b start
	
	@dup dcb 0xba,0				; room for header

start



palSet:
;;  set pal: entries are 256x555bpp I think
	mov	r0,#0x05000000 ; palette address
;
	mov r1,#256
	mov r2,#0  ; format: 0BGR
;
; repeating palette to fill scr..
;
.g
	strh    r2,[r0,#2]!			; store colour
	add r2,r2,#(1<<5)      ; b

	subs r1,r1,#1
	bpl .g


;
;;	copy main loop to iwram 
;

	addr	r0,STARTIWRAM
	addr    r1,ENDIWRAM
	sub	r2,r1,r0
	mov	r1,effect
copycode:
	ldr	r3,[r0],#4
	str	r3,[r1],#4
	subs	r2,r2,#4
	bpl	copycode

;
;;	scale the mode 4 screen to make it larger veritically
;;	(older emus dont seem to support this)
;
	mov	r0,#0x04000000			; regs
	ldr	r1,=0x1444			; mode 4,bg 2 enabled,obj enabled,1d sprites
	str	r1,[r0]				; set screen mode
	ldrh	r1,[scale1]			; load h scale value (fixed point 8:8)
	strh	r1,[r0,$20]			; set h scale
	ldrh	r1,[scale2]			; load v scale value (fixed point 8:8)
	strh	r1,[r0,$26]			; set v scale

	addr	pc,effect			; branch to fire routine

scale1	@fixedw "1.0"
;scale2  @fixedw ".25"
scale2  @fixedw "1.0"
	@ltorg

;
;;	iwram code  
;


STARTIWRAM

; from	0x03000000 to the start of the code is the screen buffer
; didn't use the other mode 4 frame because i want 8-bit access

; @textarea 0x03000000 + (240*42)

;
;; fire effect
;

effect:

bigLoop:
	mov 	r0,#0x03000000			; buffer
	mov	r3,240*160
l0:
	strb 	r6,[r0],#1
	add r6,r6,r3 lsr 8
	subs 	r3,r3,#1
	bne  	l0


;;	wait vsync
;	
	mov 	r1,#0x06000000			; vram
	mov	r0,#$04000000
waitvbl:
	ldrh	r1,[r0,#4]
	tst	r1,#1
	beq	waitvbl

;;	time to copy the buffer to the real screen
;;	(using dma chan 3)
;
	mov	r0,$04000000			; regs
	mov	r1,$03000000			; screen buffer
	mov	r2,$06000000			; destination
	str	r1,[r0,$D4]			; set src
	str	r2,[r0,$D8]			; set dest
	ldr	r2,=((240*160)>>2)		; count (32 bit words)
	strh	r2,[r0,$DC]			; set count
	mov	r2,%1000010000000000		; control: 32bit, start immediately
	strh	r2,[r0,$DE]			; set control (DMA starts)

;
;;	start over
;
	b	bigLoop
	

@ltorg

@endarea

ENDIWRAM

